import {VNScene} from "./vnscene.ts";

export type Stat = "AGI" | "INT" | "CHA" | "PSI";
export const ALL_STATS: Array<Stat> = ["AGI", "INT", "CHA", "PSI"];

export type Resource = "EXP";
export const ALL_RESOURCES: Array<Resource> = ["EXP"]

export type SkillGoverning = {
  stats: Stat[],
  underTarget: number,
  target: number,
  cost: number,
  note: string,
  scoring: SkillScoring,
};
export type SkillProfile = {
  name: string,
  description: string,
}

export type SkillData = {
  governing: SkillGoverning,
  profile: SkillProfile,
  prereqs: Skill[]
}

export type ScoringCategory = "bat" | "stealth" | "charm" | "stare" | "party" | "lore";
export const SCORING_CATEGORIES: ScoringCategory[] = ["bat", "stealth", "charm", "stare", "party", "lore"];
export type SkillScoring = {[P in ScoringCategory]?: number};

export type Skill = {
  id: number
}


export type Wish = "celebritySocialite" | "nightswornAlchemist" | "batFreak";

// endings

export type Ending = {
  scene: VNScene
  personal: EndingPersonal,
  analytics: EndingAnalytics,
  successorOptions: SuccessorOption[],
  wishOptions: Wish[],

  // forcedSuccessors: number[] | null,
  // forcedWishes: number[] | null
}

export type EndingPersonal = {
  rank: string,
  domicile: string,
}

export type EndingAnalytics = {
  itemsPurloined: number,
  vampiricSkills: number,
  mortalServants: number,
}

export type SuccessorOption = {
  name: string,
  title: string,
  note: string | null, // ex "already a vampire"
  stats: Record<Stat, number>,
  talents: Record<Stat, number>
}

